#include "../bib/Aluno.hpp"

int Aluno::qtdAlunos = 0;

Aluno::Aluno()
{
    this->matricula = new std::vector<Matricula*>;
    this->qtdAlunos++;
}
Aluno::~Aluno()
{
    for (size_t i = 0; i < this->matricula->size(); i++)
    {
        delete (*this->matricula)[i];
    }
    delete this->matricula;
    this->qtdAlunos--;
}

Aluno::Aluno(std::string matriculaInstituicao, int codigo, std::string CPF, std::string RG, std::string endereco, std::string telefone, std::string email, std::string nome)
      : Pessoa(CPF, RG, endereco, telefone, email, nome)
{
    this->matriculaInstituicao = matriculaInstituicao;
    this->codigo = codigo;

    this->matricula = new std::vector<Matricula*>;
    this->qtdAlunos++;
}

std::string Aluno::getMatriculaInstituicao()
{
    return this->matriculaInstituicao;
}

void Aluno::setMatriculaInstituicao(std::string matriculaInstituicao)
{
    this->matriculaInstituicao = matriculaInstituicao;
}

int Aluno::getCodigo()
{
    return this->codigo;
}

void Aluno::setCodigo(int codigo)
{
    this->codigo = codigo;
}

std::vector<Matricula*>* Aluno::getMatricula()
{
    return this->matricula;
}

void Aluno::setMatricula(std::vector<Matricula*>* matricula)
{
    this->matricula = matricula;
}

void Aluno::matricular(Turma* turma)
{
    int codigo;
    std::time_t rawtime;
    std::time (&rawtime);
    std::tm diaMatricula = *(localtime(&rawtime));
    int nota;
    std::string situacao;

    std::cout << "Codigo: ";
    std::cin >> codigo;
    std::cout << "Situacao: ";
    std::cin >> situacao;

    Matricula* matricula = new Matricula();
    matricula->setCodigo(codigo);
    matricula->setDiaMatricula(diaMatricula);
    matricula->setSituacao(situacao);
    matricula->setTurma(turma);

    (this->matricula)->push_back(matricula);

    std::cout << "Matriculado!" << std::endl;
}

void Aluno::imprimeHorario()
{
    std::cout << "Horario" << std::endl;
    std::cout << "Nome: " << this->getNome() << std::endl;
    for (size_t i = 0; i < (this->getMatricula())->size(); i++)
    {
        std::cout << "Turma: " << (*this->getMatricula())[i]->getTurma()->getCodigo() << std::endl;
        std::cout << "Serie: " << (*this->getMatricula())[i]->getTurma()->getSerie()->getCodigo() << std::endl;
        std::cout << "Curso: " << (*this->getMatricula())[i]->getTurma()->getSerie()->getCurso()->getCodigo() << std::endl;
        std::cout << "Idioma: " << (*this->getMatricula())[i]->getTurma()->getSerie()->getCurso()->getIdioma()->getCodigo() << std::endl;
        std::cout << std::endl;
    }
}