#ifndef _PEDIDO_HPP_
#define _PEDIDO_HPP_

#include <iostream>
#include <vector>
#include <ctime>

class Cliente;
class Funcionario;
class ItemDePedido;

class Pedido
{
private:
    float valorTotal;
    std::tm data;
    std::string status;
    std::string formaPgto;

    Cliente* cliente;
    Funcionario* funcionario;
    std::vector<ItemDePedido*>* itemDePedido;

public:
    int qtdPedidos;

    Pedido();
    Pedido(float valorTotal, std::tm data, std::string status, std::string formaPgto, Cliente* cliente, Funcionario* funcionario);
    ~Pedido();

    void addItemDePedido(ItemDePedido* itemDePedido);
    
    float getValorTotal();
    void setValorTotal(float valorTotal);
    std::tm getData();
    void setData(std::tm data);
    std::string getStatus();
    void setStatus(std::string status);
    std::string getFormaPgto();
    void setFormaPgto(std::string formaPgto);

    Cliente *getCliente();
    void setCliente(Cliente *cliente);
    Funcionario *getFuncionario();
    void setFuncionario(Funcionario *funcionario);
    std::vector<ItemDePedido*>* getItemDePedido();
    void setItemDePedido(std::vector<ItemDePedido*>* itemDePedido);
};

#endif