#include "../bib/Pedido.hpp"

int qtdPedidos = 0;

Pedido::Pedido()
{
    this->qtdPedidos ++;
    this->itemDePedido = new std::vector<ItemDePedido*>;
}

Pedido::Pedido(float valorTotal, std::tm data, std::string status, std::string formaPgto, Cliente* cliente, Funcionario* funcionario)
{
    this->valorTotal = valorTotal;
    this->data = data;
    this->status = status;
    this->formaPgto = formaPgto;
    this->cliente = cliente;
    this->funcionario = funcionario;

    this->qtdPedidos ++;
    this->itemDePedido = new std::vector<ItemDePedido*>;
}

Pedido::~Pedido()
{
    this->qtdPedidos --;
    delete this->itemDePedido;
}

void Pedido::addItemDePedido(ItemDePedido* itemDePedido)
{
    this->itemDePedido->push_back(itemDePedido);
}

float Pedido::getValorTotal()
{
    return this->valorTotal;
}

void Pedido::setValorTotal(float valorTotal)
{
    this->valorTotal = valorTotal;
}

std::tm Pedido::getData()
{
    return this->data;
}

void Pedido::setData(std::tm data)
{
    this->data = data;
}

std::string Pedido::getStatus()
{
    return this->status;
}

void Pedido::setStatus(std::string status)
{
    this->status = status;
}

std::string Pedido::getFormaPgto()
{
    return this->formaPgto;
}

void Pedido::setFormaPgto(std::string formaPgto)
{
    this->formaPgto = formaPgto;
}

Cliente* Pedido::getCliente()
{
return this->cliente;
}

void Pedido::setCliente(Cliente *cliente)
{
this->cliente = cliente;
}

Funcionario* Pedido::getFuncionario()
{
    return this->funcionario;
}

void Pedido::setFuncionario(Funcionario *funcionario)
{
    this->funcionario = funcionario;
}

std::vector<ItemDePedido*>* Pedido::getItemDePedido()
{
    return this->itemDePedido;
}

void Pedido::setItemDePedido(std::vector<ItemDePedido*>* itemDePedido)
{
    this->itemDePedido = itemDePedido;
}