#include <iostream>
#include <ctime>

#include "bib/Cliente.hpp"
#include "bib/Funcionario.hpp"
#include "bib/ItemDePedido.hpp"
#include "bib/Pedido.hpp"
#include "bib/Produto.hpp"
#include "bib/PessoaFisica.hpp"
#include "bib/PessoaJuridica.hpp"

int main()
{

    Cliente *cliente1, *cliente2, *cliente3;
    Funcionario *funcionario1, *funcionario2, *funcionario3;
    ItemDePedido *itemDePedido1, *itemDePedido2, *itemDePedido3;
    Pedido *pedido1, *pedido2, *pedido3;
    Produto *produto1, *produto2, *produto3;
    PessoaFisica *pessoaFisica1;
    PessoaJuridica *pessoaJuridica1;

    std::time_t rawtime;
    std::time (&rawtime);
    std::tm dataTM = *(localtime(&rawtime));

    cliente1 = new Cliente("Um", "Um", "Um");
    funcionario1 = new Funcionario("Um", "Um", "Um", "Um");
    pedido1 = new Pedido(1.0, dataTM, "Um", "Um", cliente1, funcionario1);
    produto1 = new Produto(1, "Um", "Um", 1, 1.0);
    itemDePedido1 = new ItemDePedido(1, 1.0, pedido1, produto1);
    pedido1->addItemDePedido(itemDePedido1);
    cliente1->addPedido(pedido1);

    cliente2 = new Cliente("Dois", "Dois", "Dois");
    funcionario2 = new Funcionario("Dois", "Dois", "Dois", "Dois");
    pedido2 = new Pedido(2.0, dataTM, "Dois", "Dois", cliente2, funcionario2);
    produto2 = new Produto(2, "Dois", "Dois", 2, 2.0);
    itemDePedido2 = new ItemDePedido(2, 2.0, pedido2, produto2);
    pedido2->addItemDePedido(itemDePedido2);
    cliente2->addPedido(pedido2);

    cliente3 = new Cliente("Tres", "Tres", "Tres");
    funcionario3 = new Funcionario("Tres", "Tres", "Tres", "Tres");
    pedido3 = new Pedido(3.0, dataTM, "Tres", "Tres", cliente3, funcionario3);
    produto3 = new Produto(3, "Tres", "Tres", 3, 3.0);
    itemDePedido3 = new ItemDePedido(3, 3.0, pedido3, produto3);
    pedido3->addItemDePedido(itemDePedido3);
    cliente3->addPedido(pedido3);

    cliente1->imprime();

    pessoaFisica1 = new PessoaFisica("Cinco", dataTM, "Cinco", "Cinco", "Cinco", "Cinco", "Cinco");
    pessoaJuridica1 = new PessoaJuridica("Quatro", "Quatro", "Quatro", "Quatro", "Quatro", "Quatro");

    std::cout << pessoaFisica1->getNome() << std::endl;

    delete cliente1; delete cliente2; delete cliente3;
    delete funcionario1; delete funcionario2; delete funcionario3;
    delete itemDePedido1; delete itemDePedido2; delete itemDePedido3;
    delete pedido1; delete pedido2; delete pedido3;
    delete produto1; delete produto2; delete produto3;

    delete pessoaFisica1;
    delete pessoaJuridica1;

    return 0;
}