#ifndef _CONTA_HPP_
#define _CONTA_HPP_

#include <iostream>
#include <vector>
#include "Correntista.hpp"
#include "Transacao.hpp"

class Conta
{
protected:
    std::string numeroDaConta;
    std::string agencia;
    float saldo;

    Correntista* correntista;
    std::vector<Transacao*>* transacao;

public:
    Conta();
    Conta(std::string numeroDaConta, std::string agencia, float saldo);
    ~Conta();

    std::string getNumeroDaConta();
	void setNumeroDaConta(std::string numeroDaConta);
	std::string getAgencia();
	void setAgencia(std::string agencia);
	float getSaldo();
	void setSaldo(float saldo);
	Correntista* getCorrentista();
	void setCorrentista(Correntista* correntista);
	std::vector<Transacao*>* getTransacao();
	void setTransacao(std::vector<Transacao*>* transacao);
    void addTransacao(Transacao* transacao);

    void deposito(float valor);
    virtual void retirada(float valor) = 0;
    virtual void extrato() = 0;
};

#endif